package com.pj.rabbitmq;

import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson.JSONObject;
import com.pj.bank_byte.BankByte;
import com.pj.bank_byte.BankByteMapper;
import com.pj.dto.DataDto;
import com.pj.enummj.FinishStatus;
import com.pj.utils.ht.AESUtil;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.rabbit.connection.CachingConnectionFactory;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Author Mechrevo
 * @Date 2023 08 25 12 30
 **/
@Component
public class MessageSender {

    private final RabbitTemplate levelOneConnectionFactory;
    private final RabbitTemplate levelTwoConnectionFactory;
    private final RabbitMQProperties rabbitMQProperties;

    @Autowired
    public MessageSender(@Qualifier("levelOneConnectionFactory") CachingConnectionFactory levelOneConnectionFactory,
                           @Qualifier("levelTwoConnectionFactory") CachingConnectionFactory levelTwoConnectionFactory,RabbitMQProperties rabbitMQProperties) {
        this.levelOneConnectionFactory = new RabbitTemplate(levelOneConnectionFactory);
        this.levelTwoConnectionFactory = new RabbitTemplate(levelTwoConnectionFactory);
        this.rabbitMQProperties=rabbitMQProperties;
    }

    public void sendToLevelOneMQ(String message) {
        levelOneConnectionFactory.convertAndSend(rabbitMQProperties.getLevelOneSendQueue(),message);
    }
    public void sendToLevelTwoMQ(String message) {
        levelTwoConnectionFactory.convertAndSend(rabbitMQProperties.getLevelTwoSendQueue(),message);
    }


}
